/*++

Module:

    MersenneTwister.h

Authors:

    Sharvil Nanavati (sharvil) 2005-11-24

--*/

#pragma once

#include "base.h"

class MersenneTwister
{
	public:
		MersenneTwister();
		explicit MersenneTwister(uint32 seed);
		~MersenneTwister();

		uint32 Limit() const;

		void Seed(uint32 seed);
		uint32 Random();
		int32 RandomPositive();

	private:
		// Period parameters
		static const uint32 N = 624;
		static const uint32 M = 397;

		uint32 mt[N];       // The array for the state vector
		uint32 mti;         // mti == N + 1 means mt[N] is not initialized
};
