/*++

Copyright (c) Sydus.

Module:

    SubSpaceCrypt.h

Authors:

    Sharvil Nanavati (sharvil) 2008-04-17

--*/

#pragma once

#include "base.h"
#include "ICryptosystem.h"

class SubSpaceCrypt : public ICryptosystem
{
	public:
		explicit SubSpaceCrypt(int32 key);
		~SubSpaceCrypt();

		void Encrypt(BString & data);
		void Decrypt(BString & data);

		void Encrypt(uint8 * data, uint32 length);
		void Decrypt(uint8 * data, uint32 length);

	private:
		static const uint32 csKeystreamLength= 520;

		uint32 ReadKeystream(uint32 index) const;
		uint32 ReadValue(const uint8 * data, uint32 length, uint32 offset) const;
		void WriteValue(uint8 * data, uint32 length, uint32 offset, uint32 value) const;

		int32 iKey;
		uint8 iKeystream[csKeystreamLength];
};
