#pragma once

#include "base.h"
#include "NetLib.h"

class Config
{
	public:
		Config();

		bool Load();
		void RestoreDefaults();

		const StringISet & GetUpstreamServerList() const;
		uint32 GetPasswordReclaimTime() const;
		uint32 GetZoneListRefreshPeriod() const;
		uint32 GetStatisticsDumpPeriod() const;
		uint32 GetConfigReloadPeriod() const;
		uint16 GetBaseListenPort() const;

		bool IsZoneIpBanned(const InetAddress & ip) const;
		bool IsZoneNameBanned(const std::string & name) const;

	private:
		typedef std::list <CidrNetmask> NetmaskList;

		static const std::string KConfigFile;

		StringISet iUpstreamServers;
		uint32 iPasswordReclaimSeconds;
		uint32 iZoneListDownloadSeconds;
		uint32 iStatisticsDumpSeconds;
		uint32 iConfigReloadSeconds;
		uint16 iBaseListenPort;
		StringISet iZoneBanPrefixes;
		StringISet iZoneBanStrings;
		NetmaskList iZoneBanNetmasks;

		uint32 iLastModifiedTime;
};
